////////////////////////////////////////////////////////////////////////////////
//                                 APICulture
//                        (c)  , 1999-2000
//    http://mazurkin.virtualave.net, mazurkin@mailru.com, mazurkin@chat.ru
// _____________________________________________________________________________
//                          Subclass'
////////////////////////////////////////////////////////////////////////////////

unit AclDialogSubclass;

interface

uses
  AclControlSubclass,
  Windows, Messages, WinLite;

type
  TDialogSubclass = class(TLiteDialogBox)
  private
    FComboBox   : TControlSubclass;
  protected
    procedure   CreateDialogParams(var DialogParams: TDialogParams); override;
  protected
    procedure   OnCommand(var Msg: TWMCommand); message WM_COMMAND;
    procedure   OnInitDialog(var Msg: TWMInitDialog); message WM_INITDIALOG;
    procedure   OnDestroy(var Msg: TWMDestroy); message WM_DESTROY;
    procedure   OnSysCommand(var Msg: TWMSysCommand); message WM_SYSCOMMAND;
  end;

implementation

{$I res\resource.inc}

////////////////////////////////////////////////////////////////////////////////
// TDialogOpenGL
// _____________________________________________________________________________
//  / 
////////////////////////////////////////////////////////////////////////////////

////////////////////////////////////////////////////////////////////////////////
//   
////////////////////////////////////////////////////////////////////////////////
procedure TDialogSubclass.CreateDialogParams(var DialogParams: TDialogParams);
begin
  inherited;
  DialogParams.Template := MAKEINTRESOURCE(DIALOGSUBCLASS);
end;

////////////////////////////////////////////////////////////////////////////////
//  
////////////////////////////////////////////////////////////////////////////////
procedure TDialogSubclass.OnInitDialog(var Msg: TWMInitDialog);
begin
  //   
  FComboBox := TControlSubclass.CreateSubclassed(GetDlgItem(WndHandle, IDC_SUBCLASS_CONTROL));
  // 
  Msg.Result := 1;
end;

////////////////////////////////////////////////////////////////////////////////
//  
////////////////////////////////////////////////////////////////////////////////
procedure TDialogSubclass.OnDestroy(var Msg: TWMDestroy);
begin
  //   
  FComboBox.Free;
  // 
  Msg.Result := 0;
end;

////////////////////////////////////////////////////////////////////////////////
// TDialogOpenGL
// _____________________________________________________________________________
//   
////////////////////////////////////////////////////////////////////////////////

////////////////////////////////////////////////////////////////////////////////
//    
////////////////////////////////////////////////////////////////////////////////
procedure TDialogSubclass.OnCommand(var Msg: TWMCommand);
begin
  //    "OK" -  
  if Msg.ItemID = IDC_SUBCLASS_OK then
  begin
    EndDialog(WndHandle, IDOK);
    Msg.Result := 1;
  end;
end;

////////////////////////////////////////////////////////////////////////////////
//  
////////////////////////////////////////////////////////////////////////////////
procedure TDialogSubclass.OnSysCommand(var Msg: TWMSysCommand);
begin
  //      ,   
  if Msg.CmdType = SC_CLOSE then
  begin
    EndDialog(WndHandle, IDOK);
    Msg.Result := 0;
    Exit;
  end;
  //     
  with TMessage(Msg) do
    DefWindowProc(WndHandle, Msg, WParam, LParam);
end;

end.
